# -*- coding: utf-8 -*-
from setuphelpers import *
import platform

# Declaring specific app values (TO CHANGE)
real_bin_name = "virtio-win-gt-x64.msi"
bin_name_string = "virtio-win-gt-x64-%s.msi"


def update_package():
    print("Download/Update package content from upstream binary sources")

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system() == "Windows" and isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Specific app values
    url_dl = "https://fedorapeople.org/groups/virt/virtio-win/direct-downloads/latest-virtio/%s" % real_bin_name

    # Downloading latest binaries
    if isfile(real_bin_name):
        remove_file(real_bin_name)
    if not isfile(real_bin_name):
        print("Downloading: " + real_bin_name)
        wget(url_dl, real_bin_name, proxies=proxy)

        # Get version from file
        version = get_msi_properties(real_bin_name)["ProductVersion"]
        os.rename(real_bin_name, bin_name_string % version)
        # Change version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-", 1)[1]) + 1)
        control.save_control_to_wapt()
        print("Changing version to " + control.version + " in WAPT\\control")
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")
